Public Class Form1
    Private Const REG_PRODUCT_KEY As String = "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows NT\CurrentVersion"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Get the Environment.OSVersion.
        Label1.Text = Environment.OSVersion.ToString()

        ' Get the interpreted version information.
        lblPlatform.Text = Environment.OSVersion.Platform.ToString
        lblOSVersion.Text = GetOSVersion()
        lblMajor.Text = Environment.OSVersion.Version.Major.ToString
        lblMinor.Text = Environment.OSVersion.Version.Minor.ToString
        lblBuild.Text = Environment.OSVersion.Version.Build.ToString
        lblRevision.Text = Environment.OSVersion.Version.Revision.ToString
        lblRegistry.Text = My.Computer.Registry.GetValue( _
            REG_PRODUCT_KEY, "ProductName", "???")
    End Sub

    ' Return the OS version, build, and platform ID.
    '            dwPlatformID  dwMajorVersion  dwMinorVersion
    ' Win3.1          0               ?               ?
    ' Win95           1               4               0
    ' Win98           1               4              10
    ' WinME           1               4              90
    ' NT 3.51         2               3              51
    ' NT 4.0          2               4               0
    ' Win2000         2               5               0
    ' WinXP           2               5               1
    ' Win2003         2               5               2
    ' Vista           2               6               0
    ' Win2008 Server  2               6               0
    Public Function GetOSVersion() As String
        Select Case Environment.OSVersion.Platform
            Case PlatformID.Win32S
                Return "Win 3.1"
            Case PlatformID.Win32Windows
                Select Case Environment.OSVersion.Version.Minor
                    Case 0
                        Return "Win95"
                    Case 10
                        Return "Win98"
                    Case 90
                        Return "WinME"
                    Case Else
                        Return "Unknown Win32"
                End Select
            Case PlatformID.Win32NT
                Select Case Environment.OSVersion.Version.Major
                    Case 3
                        Return "NT 3.51"
                    Case 4
                        Return "NT 4.0"
                    Case 5
                        Select Case Environment.OSVersion.Version.Minor
                            Case 0
                                Return "Win2000"
                            Case 1
                                Return "WinXP"
                            Case 2
                                Return "Win2003"
                        End Select
                    Case 6
                        Dim txt As String = My.Computer.Registry.GetValue( _
                            REG_PRODUCT_KEY, "ProductName", "")
                        If txt.ToLower().Contains("vista") Then Return "Vista"
                        If txt.ToLower().Contains("server") Then Return "Win2008"
                        Return "Unknown Win32NT6"
                    Case Else
                        Return "Unknown Win32NT"
                End Select
            Case PlatformID.WinCE
                Return "Win CE"
            Case PlatformID.Unix
                Return "Unix"
        End Select

        Return "Unknown"
    End Function
End Class
